#! /usr/bin/env python
# *******************************
# PyroControl usb testing
# *******************************
# Used to control computer via remote
#To get to work in linux, permission wise, so wouldn't have to be run as root,
#added following lines to /etc/udev/permissions.rules
# Microchip
#SUBSYSTEM=="usb_device", GROUP="plugdev", SYSFS{idVendor}=="04d8"


import usb
import time
import commands
import string
import config
import threading
import urllib

class myth_backend_c(threading.Thread):
	def __init__(self, ip, port):
		#self.xml_data = ''
		self.valid = False
		self.temp_valid = False
		self.ip = ip
		self.port = port
		self.Myth_capacity = 0.0
		self.Myth_recording = False
		threading.Thread.__init__ ( self )
	
	def get_XML(self):
		self.run()
	
	def find_s(self, xml_data, s):
		#Find all the instances of s in put in list.
		i = 0
		l = []
		while i !=-1:
			i = xml_data.find(s,i+1)
			if i != -1: l.append(i)
		return l
			
	def check_encoder(self, encoder_index, xml_data):
		#Check each encoder
		recording = False
		self.temp_valid = True
		
		for index in encoder_index:
			state_index = xml_data.find(' state=', index)
			if config.debug: print "State Index", state_index
			if state_index!=-1:
				if xml_data[state_index + 8] == '4':
					recording = True
			else:
				self.temp_valid = False
		return recording
	
	def check_storage(self, xml_data):
		#Find the drive capacity, for capacity status light.
		self.temp_valid = True
		total_start = xml_data.find('<Storage drive_total_free="') + 27
		#print xml_data[total_start:total_start+20]
		total_end = xml_data.find('"',total_start+1)
		if (total_start !=-1) & (total_end !=-1):
			total_free = int(xml_data[total_start:total_end])
			#print total_free
		else:
			self.temp_valid = False
		#Find total_used
		total_start = xml_data.find('drive_total_used="', total_end) + 18
		#print xml_data[total_start:total_start+20]
		total_end = xml_data.find('"',total_start+1)
		if (total_start !=-1) & (total_end !=-1):
			total_used = int(xml_data[total_start:total_end])
			#print total_used
		else:
			self.temp_valid = False
		return 100.0 * total_used / (total_free + total_used)
		
			
	def decode_xml(self, xml_data):
		#Insted of decoding actually xml, just using find commands.
		#Determine if any tuner is currently recording
		#1st find all instances of <Encoder
		#print xml_data
		#Assume valid
		self.temp_valid = True
		encoder_index = self.find_s(xml_data, '<Encoder ')
		if config.debug: print "Encoder_index", encoder_index
		#Check encoders to see if any of them are in state 4, recording.
		self.Myth_recording = self.check_encoder(encoder_index, xml_data)
		#Check for 
		self.Myth_capacity = self.check_storage(xml_data)
	def print_status(self):
		if self.valid:
			backendstatus = "UP  "
		else:
			backendstatus = "DOWN"
		if self.Myth_recording:
			recording = "YES"
		else:
			recording = "NO "
		capacity = self.Myth_capacity
		if self.valid:
			print "BackendStatus = %s --- Recording = %s --- Capacity = %5.1f" %(backendstatus, recording, capacity)
		else:
			print "BackendStatus = DOWN --- Recording = UNKNOWN --- Capacity = UNKOWN"
	
	def run(self):
		
		try:
			url_out = 'http://' + self.ip + ':' + str(self.port) + '/xml'
			if config.debug: print "Attempting to connect to %s ...." %url_out
			f = urllib.urlopen(url_out)
			print "Decoding XML from Backend ......"
			self.decode_xml(f.read())	
			#Put this valid check at end, so self.valid will only be true if its runs successfully.
			if self.temp_valid == True:
				self.valid = True
			else:
				self.valid = False
		except:
			self.valid = False
		
		self.print_status()

		
class keybind_c(object):
#Class that will be in an list
# that will have each keycode, keyname, and argument to pass to xet
	def __init__(self, keycode, funccode, name, arg):
		self.keycode = keycode
		self.funccode = funccode
		self.keyname = name
		self.arg = arg

class send_keys_c(object):
	
	def __init__(self):
		self.key_held = False
	
	def decode(self, IR_data, keydata):
		#Takes the data from the usb receiver and determines what key's to press
		for t in IR_data: #Go to each touple
			if ((t[0] == 0xAA) & (t[1] == 0xAA)): #Just for the repeat code (key on remote being held down.)
				pass #Repeat code
			else: #Attempt to decode keycode in keydata.
				found = False
				for key in keydata:
					if ((key.keycode == t[0]) & (key.funccode == t[1])):
						self.xte_key(key.arg)
						print "Key Pressed --- %s" %key.keyname
						found = True
						
				if found == False:
					print "Key not found Code is %2X %2X" %(t[0],t[1])
	
	def xte_key(self, arg):
		comm = "xte -x:0  " + arg
		#comm = "xvkbd -text " + arg 
		result = commands.getstatusoutput(comm)
		print comm
		print result
	

class file_c(object):
#The class the handles the remote.conf file.
	def __init__(self, filename):
		self.filename = filename
	
		def decode(line):
			#Little function to decode line
			def toHex(s): #Convert string to hex
				i = string.atoi(s,16)
				return i
			
			t = line.split(',')
			keycode= toHex(t[0]) #Convert 1st argument to hex value
			funccode = toHex(t[1])
			name = t[2] #Name String
			arg = t[3]
			return keycode, funccode, name, arg

		f=open(filename)
		array = f.readlines()
		self.keydata = []
		for line in array:
			#Decode each line	
			keycode, funccode,name, arg = decode(line[:-1]) #Take out newline character at end.
			s = keybind_c(keycode,funccode, name,arg)
			self.keydata.append(s)	
			
	def print_keys(self):
		
		for i in self.keydata:
			print i.keycode, i.keyname, i.arg

class DeviceNotFoundError(Exception):
	def  __init__(self):
		pass
	def __str__(self):
		return "Could not find USB Device"

class UsbDevice:
	def __init__(self, vendor_id, product_id):
		self.vendor_id = vendor_id
		self.product_id = product_id
		self.connected = False
		self.error_count = 0
	def connect(self):
		skip =0
		busses = usb.busses()
		self.handle = None
		count = 0
		for bus in busses:
			devices = bus.devices
			for dev in devices:
				if dev.idVendor==self.vendor_id and dev.idProduct==self.product_id:
					if count==skip:
						self.dev = dev
						self.conf = self.dev.configurations[0]
						self.intf = self.conf.interfaces[0][0]
						self.endpoints = []
						for endpoint in self.intf.endpoints:
							self.endpoints.append(endpoint)
						return
					else:
						count=count+1
		raise DeviceNotFoundError
	
	def open(self):
		if self.handle:
			self.handle = None
		self.handle = self.dev.open()
		#self.handle.detachKernelDriver(0)
		#self.handle.detachKernelDriver(1)
		#self.handle.setConfiguration(self.conf)
		self.handle.claimInterface(self.intf)
		
			
		#self.handle.setAltInterface(self.intf)

	def try_connect(self, retry_time):
		while self.connected == False:
			try:
				print "Attempting to connect to receiver...."
				self.connect()
				self.open()
				print "Reciever Connected....."
				self.connected = True
				self.error = 0 
			except (usb.USBError, DeviceNotFoundError):
			#except:
				self.connected = False
				print "Reciever Not Found will Retry in %s seconds...." %(retry_time)
				time.sleep(retry_time)

	def send_data(self, recording, backend_status, capacity):
		if self.connected:
			#Send data
			backend_status = not backend_status
			#print capacity, flash_level, 0xFF
			byte1 = recording + backend_status * 2
			if backend_status == True: #Backend is down
				byte0 = 255 #Flash both RED LIGHTS
			else:
				#Calculate form capacity the color.

				if capacity >= config.Red_Flash:
					byte0 = 0xFF
				elif capacity >= config.Red_Solid:
					byte0 = 0xFE
				elif capacity >= config.Yellow:
					byte0 = 0xA0 #Full Yellow
				else:
					byte0 = 0x01 #Full green
					
				#	byte0 = int(capacity / flash_level * 0xFF)
					
			#print "Output USB %X %X" %(byte0,byte1)
			try: 
				self.handle.controlMsg(0x40, 2, (byte0,byte1,128,128,128,128,128,128))
				self.error = 0 
			except:
				print "ERROR SENDING TO USB"
				self.error +=1
				#self.connected = False
	def check_data(self):
		if self.connected:
			#Recieve data
			#try:
			#print "Retrieving IR Codes (if any)"
			t = self.handle.controlMsg(0xC0, 4, 8)
			#except: #If error than try to reconnect.
			#self.connected = False
			#print "ERROR IN RETRIVING IR CODES"
			#Decode data
			out = []
			for i in range(0,8,2):
				if ((t[i] != 0xBB) | (t[i+1] != 0xBB)):
					out.append((t[i],t[i+1]))
			#print t
			return out
			
	def check_error(self):
		if self.error >= config.Error_Count:
			self.error =0
			self.connected = False
			
class count_c(object):
	
	def __init__(self, max):
		self.max = int(max)
		self.count =0
	def step(self):
		self.count = self.count +1
		if self.count >= self.max:
			self.count = 0
			return True
		else:
			return False

if __name__ == '__main__':
	#Load config file.
	config_file = file_c('/etc/tatir/remote_xte.conf')
	config_file.print_keys()
	send_keys = send_keys_c()
	#Define USB Device
	USB_receiver = UsbDevice(0x4d8, 0x4)
	backend = myth_backend_c(config.MythBackend_IP, config.MythBackend_Port)
	backend.start()
	USB_update = count_c((config.USB_update_delay / config.IR_update_delay))
	backend_XML_update = count_c(config.Backend_XML_update_delay / config.IR_update_delay)
	
	
	while 1==1: #Infinite loop
		#Try to connect to USB Device if not already connected
		if USB_receiver.connected == False: USB_receiver.try_connect(config.USB_Retry_Time)
		
		#Get new XML data if delay has happened.
		if backend_XML_update.step():
			backend.get_XML()
		if USB_update.step():
			USB_receiver.send_data(backend.Myth_recording, backend.valid, backend.Myth_capacity)
		else:
		#Check for new IR_Codes only do it USB_update is not run.
			try:
				l = USB_receiver.check_data()
				send_keys.decode(l, config_file.keydata)
				USB_receiver.error = 0
			except:
				print "ERROR GETTING IR CODES FROM RECIEVER."
				USB_receiver.error +=1
		#Time delay
		time.sleep(config.IR_update_delay) 
		USB_receiver.check_error() #Check to see if error count is high enough to disconnect device.
		
